/**
 * \file  WebotsEPuckNXTdifferentialRobotControlStatus.h
 *  WebotsEPuckNXTdifferentialRobotControlStatus
 *  Created by
 *  \author Vlad Estivill-Castro
 *  \date 29/09/2014.
 */

/*
 *
 * This is module acts as a bridge between the whiteboard and a LEGO Mindstorm
 * WEBOTS. Sensors can be commanded to post updates and actuators can be
 * controlled. Currently the module only supports Webots camera and motors.
 *
 *  Copyright 2012 Vlad Estivill-Castro. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials
 *    provided with the distribution.
 *
 * 3. All advertising materials mentioning features or use of this
 *    software must display the following acknowledgement:
 *
 *        This product includes software developed by Rene Hexel.
 *
 * 4. Neither the name of the author nor the names of contributors
 *    may be used to endorse or promote products derived from this
 *    software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * -----------------------------------------------------------------------
 * This program is free software; you can redistribute it and/or
 * modify it under the above terms or under the terms of the GNU
 * General Public License as published by the Free Software Foundation;
 * either version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see http://www.gnu.org/licenses/
 * or write to the Free Software Foundation, Inc., 51 Franklin Street,
 * Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */


/****************** I M P O R T A N T   */
/* is <class_name>_DEFINED              */
/***************************************/

#ifndef WebotsEPuckNXTdifferentialRobotControlStatus_DEFINED
#define WebotsEPuckNXTdifferentialRobotControlStatus_DEFINED

#include <cstdlib>
#include <sstream>
#include <gu_util.h>

/******************** I M O R T A N T	*/
/* The corresponding C structure	*/
/***************************************/
#include "webots_epuck_nxt_differential_robot/wb_webots_epuck_NXT_differential_robot.h"

namespace guWhiteboard {

	class WebotsEPuckNXTdifferentialRobotControlStatus:  public wb_webots_epuck_NXT_differential_robot
	{
	public:
        /** designated constructor **/
	WebotsEPuckNXTdifferentialRobotControlStatus(): wb_webots_epuck_NXT_differential_robot() {}

	/** copy constructor **/
	/*
	 WebotsEPuckNXTdifferentialRobotControlStatus(const WebotsEPuckNXTdifferentialRobotControlStatus &other):
	      _left_motor._motor_power(other._left_motor._motor_power) 
	       	{}
		*/

	/** copy assignment operator **/

	/** copy assignment operator **/
	 /**  INTERESTING !!!! */

#ifdef WHITEBOARD_POSTER_STRING_CONVERSION

#define SEPARATOR_IS_COMMA ','
#define SEPARATOR_IS_COLON ':'
#define IS_VISIBLE_ID 'I'

	std::string description() { 
		std::ostringstream ss;
		ss << "a test of description";
		return ss.str();
	}


#endif // WHITEBOARD_POSTER_STRING_CONVERSION

	}; // class

} //namespace

#endif // WebotsEPuckNXTdifferentialRobotControlStatus_DEFINED

